function NIIRAS2Analyze(nii_fname,analyze_fname)
%NIIRAS2Analyze(nii_fname,analyze_fname)
%
%Convert a nifti in RAS orientation file into an analyze format image in RAS orientation. 
%
%Yonggang Shi
%May 2015

nii = load_untouch_nii(nii_fname);
nii.img(isnan(nii.img)) = 0;
  switch nii.hdr.dime.datatype
   case   1,
      hdr.dime.bitpix = 1;  precision = 'ubit1';
   case   2,
      hdr.dime.bitpix = 8;  precision = 'uint8';
   case   4,
      hdr.dime.bitpix = 16; precision = 'int16';
   case   8,
      hdr.dime.bitpix = 32; precision = 'int32';
   case  16,
      hdr.dime.bitpix = 32; precision = 'float32';
   case  32,
      hdr.dime.bitpix = 64; precision = 'float32';
   case  64,
      hdr.dime.bitpix = 64; precision = 'float64';
   case 128,
      hdr.dime.bitpix = 24; precision = 'uint8';
   case 256 
      hdr.dime.bitpix = 8;  precision = 'int16'; %change from int8 to int16 as int8 is not supported in analyze
   case 511 
      hdr.dime.bitpix = 96; precision = 'float32';
   case 512 
      hdr.dime.bitpix = 16; precision = 'int32'; %change from uint16 to int16 as int32 is not supported in analyze
   case 768 
      hdr.dime.bitpix = 32; precision = 'float32';%change from uint32 to float32 as int32 is not supported in analyze
   case 1024
      hdr.dime.bitpix = 64; precision = 'float64'; %change from int64 to float64 as int64 is not supported in analyze
   case 1280
      hdr.dime.bitpix = 64; precision = 'float64'; %change from uint64 to float64 as uint64 is not supported in analyze
   case 1792,
      hdr.dime.bitpix = 128; precision = 'float64';
   otherwise
      error('This datatype is not supported'); 
   end
% writeanalyze(abs(nii.img),size(nii.img),analyze_fname,nii.hdr.dime.pixdim(2:4),precision);
writeanalyze(nii.img,size(nii.img),analyze_fname,nii.hdr.dime.pixdim(2:4),precision);